// SPDX-License-Identifier: GPL-2.0
// Copyright (C) 2009  PaX Team <pageexec@freemail.hu>

// Generated by scripts/atomic/gen-atomic-long.sh
// DO NOT MODIFY THIS FILE DIRECTLY

#ifndef _ASM_GENERIC_ATOMIC_LONG_H
#define _ASM_GENERIC_ATOMIC_LONG_H

#include <asm/types.h>

#ifdef CONFIG_64BIT
typedef atomic64_t atomic_long_t;

#ifdef CONFIG_PAX_REFCOUNT
typedef atomic64_unchecked_t atomic_long_unchecked_t;
#else
typedef atomic64_t atomic_long_unchecked_t;
#endif

#define ATOMIC_LONG_INIT(i)		ATOMIC64_INIT(i)
#define atomic_long_cond_read_acquire	atomic64_cond_read_acquire
#define atomic_long_cond_read_relaxed	atomic64_cond_read_relaxed
#else
typedef atomic_t atomic_long_t;

#ifdef CONFIG_PAX_REFCOUNT
typedef atomic_unchecked_t atomic_long_unchecked_t;
#else
typedef atomic_t atomic_long_unchecked_t;
#endif

#define ATOMIC_LONG_INIT(i)		ATOMIC_INIT(i)
#define atomic_long_cond_read_acquire	atomic_cond_read_acquire
#define atomic_long_cond_read_relaxed	atomic_cond_read_relaxed
#endif

#ifdef CONFIG_64BIT

static inline long __turn_off_size_overflow
atomic_long_read(const atomic_long_t *v)
{
	return atomic64_read(v);
}

static inline long __turn_off_size_overflow
atomic_long_read_acquire(const atomic_long_t *v)
{
	return atomic64_read_acquire(v);
}

static inline long __turn_off_size_overflow
atomic_long_read_unchecked(const atomic_long_unchecked_t *v)
{
	return atomic64_read_unchecked(v);
}

static inline void __turn_off_size_overflow
atomic_long_set(atomic_long_t *v, long i)
{
	atomic64_set(v, i);
}

static inline void __turn_off_size_overflow
atomic_long_set_release(atomic_long_t *v, long i)
{
	atomic64_set_release(v, i);
}

static inline void __turn_off_size_overflow
atomic_long_set_unchecked(atomic_long_unchecked_t *v, long i)
{
	atomic64_set_unchecked(v, i);
}

static inline void __turn_off_size_overflow
atomic_long_add(long i, atomic_long_t *v)
{
	atomic64_add(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_add_return(long i, atomic_long_t *v)
{
	return atomic64_add_return(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_add_return_acquire(long i, atomic_long_t *v)
{
	return atomic64_add_return_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_add_return_release(long i, atomic_long_t *v)
{
	return atomic64_add_return_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_add_return_relaxed(long i, atomic_long_t *v)
{
	return atomic64_add_return_relaxed(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_add(long i, atomic_long_t *v)
{
	return atomic64_fetch_add(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_add_acquire(long i, atomic_long_t *v)
{
	return atomic64_fetch_add_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_add_release(long i, atomic_long_t *v)
{
	return atomic64_fetch_add_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_add_relaxed(long i, atomic_long_t *v)
{
	return atomic64_fetch_add_relaxed(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_add_unchecked(long i, atomic_long_unchecked_t *v)
{
	atomic64_add_unchecked(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_add_return_unchecked(long i, atomic_long_unchecked_t *v)
{
	return atomic64_add_return_unchecked(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_add_unchecked(long i, atomic_long_unchecked_t *v)
{
	return atomic64_fetch_add_unchecked(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_sub(long i, atomic_long_t *v)
{
	atomic64_sub(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_sub_return(long i, atomic_long_t *v)
{
	return atomic64_sub_return(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_sub_return_acquire(long i, atomic_long_t *v)
{
	return atomic64_sub_return_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_sub_return_release(long i, atomic_long_t *v)
{
	return atomic64_sub_return_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_sub_return_relaxed(long i, atomic_long_t *v)
{
	return atomic64_sub_return_relaxed(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_sub(long i, atomic_long_t *v)
{
	return atomic64_fetch_sub(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_sub_acquire(long i, atomic_long_t *v)
{
	return atomic64_fetch_sub_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_sub_release(long i, atomic_long_t *v)
{
	return atomic64_fetch_sub_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_sub_relaxed(long i, atomic_long_t *v)
{
	return atomic64_fetch_sub_relaxed(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_sub_unchecked(long i, atomic_long_unchecked_t *v)
{
	atomic64_sub_unchecked(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_sub_return_unchecked(long i, atomic_long_unchecked_t *v)
{
	return atomic64_sub_return_unchecked(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_inc(atomic_long_t *v)
{
	atomic64_inc(v);
}

static inline long __turn_off_size_overflow
atomic_long_inc_return(atomic_long_t *v)
{
	return atomic64_inc_return(v);
}

static inline long __turn_off_size_overflow
atomic_long_inc_return_acquire(atomic_long_t *v)
{
	return atomic64_inc_return_acquire(v);
}

static inline long __turn_off_size_overflow
atomic_long_inc_return_release(atomic_long_t *v)
{
	return atomic64_inc_return_release(v);
}

static inline long __turn_off_size_overflow
atomic_long_inc_return_relaxed(atomic_long_t *v)
{
	return atomic64_inc_return_relaxed(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_inc(atomic_long_t *v)
{
	return atomic64_fetch_inc(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_inc_acquire(atomic_long_t *v)
{
	return atomic64_fetch_inc_acquire(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_inc_release(atomic_long_t *v)
{
	return atomic64_fetch_inc_release(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_inc_relaxed(atomic_long_t *v)
{
	return atomic64_fetch_inc_relaxed(v);
}

static inline void __turn_off_size_overflow
atomic_long_inc_unchecked(atomic_long_unchecked_t *v)
{
	atomic64_inc_unchecked(v);
}

static inline long __turn_off_size_overflow
atomic_long_inc_return_unchecked(atomic_long_unchecked_t *v)
{
	return atomic64_inc_return_unchecked(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_inc_unchecked(atomic_long_unchecked_t *v)
{
	return atomic64_fetch_inc_unchecked(v);
}

static inline void __turn_off_size_overflow
atomic_long_dec(atomic_long_t *v)
{
	atomic64_dec(v);
}

static inline long __turn_off_size_overflow
atomic_long_dec_return(atomic_long_t *v)
{
	return atomic64_dec_return(v);
}

static inline long __turn_off_size_overflow
atomic_long_dec_return_acquire(atomic_long_t *v)
{
	return atomic64_dec_return_acquire(v);
}

static inline long __turn_off_size_overflow
atomic_long_dec_return_release(atomic_long_t *v)
{
	return atomic64_dec_return_release(v);
}

static inline long __turn_off_size_overflow
atomic_long_dec_return_relaxed(atomic_long_t *v)
{
	return atomic64_dec_return_relaxed(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_dec(atomic_long_t *v)
{
	return atomic64_fetch_dec(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_dec_acquire(atomic_long_t *v)
{
	return atomic64_fetch_dec_acquire(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_dec_release(atomic_long_t *v)
{
	return atomic64_fetch_dec_release(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_dec_relaxed(atomic_long_t *v)
{
	return atomic64_fetch_dec_relaxed(v);
}

static inline void __turn_off_size_overflow
atomic_long_dec_unchecked(atomic_long_unchecked_t *v)
{
	atomic64_dec_unchecked(v);
}

static inline long __turn_off_size_overflow
atomic_long_dec_return_unchecked(atomic_long_unchecked_t *v)
{
	return atomic64_dec_return_unchecked(v);
}

static inline void __turn_off_size_overflow
atomic_long_and(long i, atomic_long_t *v)
{
	atomic64_and(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_and(long i, atomic_long_t *v)
{
	return atomic64_fetch_and(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_and_acquire(long i, atomic_long_t *v)
{
	return atomic64_fetch_and_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_and_release(long i, atomic_long_t *v)
{
	return atomic64_fetch_and_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_and_relaxed(long i, atomic_long_t *v)
{
	return atomic64_fetch_and_relaxed(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_andnot(long i, atomic_long_t *v)
{
	atomic64_andnot(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_andnot(long i, atomic_long_t *v)
{
	return atomic64_fetch_andnot(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_andnot_acquire(long i, atomic_long_t *v)
{
	return atomic64_fetch_andnot_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_andnot_release(long i, atomic_long_t *v)
{
	return atomic64_fetch_andnot_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_andnot_relaxed(long i, atomic_long_t *v)
{
	return atomic64_fetch_andnot_relaxed(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_or(long i, atomic_long_t *v)
{
	atomic64_or(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_or(long i, atomic_long_t *v)
{
	return atomic64_fetch_or(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_or_acquire(long i, atomic_long_t *v)
{
	return atomic64_fetch_or_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_or_release(long i, atomic_long_t *v)
{
	return atomic64_fetch_or_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_or_relaxed(long i, atomic_long_t *v)
{
	return atomic64_fetch_or_relaxed(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_xor(long i, atomic_long_t *v)
{
	atomic64_xor(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_xor(long i, atomic_long_t *v)
{
	return atomic64_fetch_xor(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_xor_acquire(long i, atomic_long_t *v)
{
	return atomic64_fetch_xor_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_xor_release(long i, atomic_long_t *v)
{
	return atomic64_fetch_xor_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_xor_relaxed(long i, atomic_long_t *v)
{
	return atomic64_fetch_xor_relaxed(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_xchg(atomic_long_t *v, long i)
{
	return atomic64_xchg(v, i);
}

static inline long __turn_off_size_overflow
atomic_long_xchg_acquire(atomic_long_t *v, long i)
{
	return atomic64_xchg_acquire(v, i);
}

static inline long __turn_off_size_overflow
atomic_long_xchg_release(atomic_long_t *v, long i)
{
	return atomic64_xchg_release(v, i);
}

static inline long __turn_off_size_overflow
atomic_long_xchg_relaxed(atomic_long_t *v, long i)
{
	return atomic64_xchg_relaxed(v, i);
}

static inline long __turn_off_size_overflow
atomic_long_xchg_unchecked(atomic_long_unchecked_t *v, long i)
{
	return atomic64_xchg_unchecked(v, i);
}

static inline long __turn_off_size_overflow
atomic_long_cmpxchg(atomic_long_t *v, long old, long new)
{
	return atomic64_cmpxchg(v, old, new);
}

static inline long __turn_off_size_overflow
atomic_long_cmpxchg_acquire(atomic_long_t *v, long old, long new)
{
	return atomic64_cmpxchg_acquire(v, old, new);
}

static inline long __turn_off_size_overflow
atomic_long_cmpxchg_release(atomic_long_t *v, long old, long new)
{
	return atomic64_cmpxchg_release(v, old, new);
}

static inline long __turn_off_size_overflow
atomic_long_cmpxchg_relaxed(atomic_long_t *v, long old, long new)
{
	return atomic64_cmpxchg_relaxed(v, old, new);
}

static inline long __turn_off_size_overflow
atomic_long_cmpxchg_unchecked(atomic_long_unchecked_t *v, long old, long new)
{
	return atomic64_cmpxchg_unchecked(v, old, new);
}

static inline bool __turn_off_size_overflow
atomic_long_try_cmpxchg(atomic_long_t *v, long *old, long new)
{
	return atomic64_try_cmpxchg(v, (s64 *)old, new);
}

static inline bool __turn_off_size_overflow
atomic_long_try_cmpxchg_acquire(atomic_long_t *v, long *old, long new)
{
	return atomic64_try_cmpxchg_acquire(v, (s64 *)old, new);
}

static inline bool __turn_off_size_overflow
atomic_long_try_cmpxchg_release(atomic_long_t *v, long *old, long new)
{
	return atomic64_try_cmpxchg_release(v, (s64 *)old, new);
}

static inline bool __turn_off_size_overflow
atomic_long_try_cmpxchg_relaxed(atomic_long_t *v, long *old, long new)
{
	return atomic64_try_cmpxchg_relaxed(v, (s64 *)old, new);
}

static inline bool __turn_off_size_overflow
atomic_long_sub_and_test(long i, atomic_long_t *v)
{
	return atomic64_sub_and_test(i, v);
}

static inline bool __turn_off_size_overflow
atomic_long_dec_and_test(atomic_long_t *v)
{
	return atomic64_dec_and_test(v);
}

static inline bool __turn_off_size_overflow
atomic_long_inc_and_test(atomic_long_t *v)
{
	return atomic64_inc_and_test(v);
}

static inline bool __turn_off_size_overflow
atomic_long_add_negative(long i, atomic_long_t *v)
{
	return atomic64_add_negative(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_add_unless(atomic_long_t *v, long a, long u)
{
	return atomic64_fetch_add_unless(v, a, u);
}

static inline bool __turn_off_size_overflow
atomic_long_add_unless(atomic_long_t *v, long a, long u)
{
	return atomic64_add_unless(v, a, u);
}

static inline bool __turn_off_size_overflow
atomic_long_inc_not_zero(atomic_long_t *v)
{
	return atomic64_inc_not_zero(v);
}

static inline bool __turn_off_size_overflow
atomic_long_inc_unless_negative(atomic_long_t *v)
{
	return atomic64_inc_unless_negative(v);
}

static inline bool __turn_off_size_overflow
atomic_long_dec_unless_positive(atomic_long_t *v)
{
	return atomic64_dec_unless_positive(v);
}

static inline long __turn_off_size_overflow
atomic_long_dec_if_positive(atomic_long_t *v)
{
	return atomic64_dec_if_positive(v);
}

#else /* CONFIG_64BIT */

static inline long __turn_off_size_overflow
atomic_long_read(const atomic_long_t *v)
{
	return atomic_read(v);
}

static inline long __turn_off_size_overflow
atomic_long_read_acquire(const atomic_long_t *v)
{
	return atomic_read_acquire(v);
}

static inline long __turn_off_size_overflow
atomic_long_read_unchecked(const atomic_long_unchecked_t *v)
{
	return atomic_read_unchecked(v);
}

static inline void __turn_off_size_overflow
atomic_long_set(atomic_long_t *v, long i)
{
	atomic_set(v, i);
}

static inline void __turn_off_size_overflow
atomic_long_set_release(atomic_long_t *v, long i)
{
	atomic_set_release(v, i);
}

static inline void __turn_off_size_overflow
atomic_long_set_unchecked(atomic_long_unchecked_t *v, long i)
{
	atomic_set_unchecked(v, i);
}

static inline void __turn_off_size_overflow
atomic_long_add(long i, atomic_long_t *v)
{
	atomic_add(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_add_return(long i, atomic_long_t *v)
{
	return atomic_add_return(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_add_return_acquire(long i, atomic_long_t *v)
{
	return atomic_add_return_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_add_return_release(long i, atomic_long_t *v)
{
	return atomic_add_return_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_add_return_relaxed(long i, atomic_long_t *v)
{
	return atomic_add_return_relaxed(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_add(long i, atomic_long_t *v)
{
	return atomic_fetch_add(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_add_acquire(long i, atomic_long_t *v)
{
	return atomic_fetch_add_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_add_release(long i, atomic_long_t *v)
{
	return atomic_fetch_add_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_add_relaxed(long i, atomic_long_t *v)
{
	return atomic_fetch_add_relaxed(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_add_unchecked(long i, atomic_long_unchecked_t *v)
{
	atomic_add_unchecked(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_add_return_unchecked(long i, atomic_long_unchecked_t *v)
{
	return atomic_add_return_unchecked(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_add_unchecked(long i, atomic_long_unchecked_t *v)
{
	return atomic_fetch_add_unchecked(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_sub(long i, atomic_long_t *v)
{
	atomic_sub(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_sub_return(long i, atomic_long_t *v)
{
	return atomic_sub_return(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_sub_return_acquire(long i, atomic_long_t *v)
{
	return atomic_sub_return_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_sub_return_release(long i, atomic_long_t *v)
{
	return atomic_sub_return_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_sub_return_relaxed(long i, atomic_long_t *v)
{
	return atomic_sub_return_relaxed(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_sub(long i, atomic_long_t *v)
{
	return atomic_fetch_sub(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_sub_acquire(long i, atomic_long_t *v)
{
	return atomic_fetch_sub_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_sub_release(long i, atomic_long_t *v)
{
	return atomic_fetch_sub_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_sub_relaxed(long i, atomic_long_t *v)
{
	return atomic_fetch_sub_relaxed(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_sub_unchecked(long i, atomic_long_unchecked_t *v)
{
	atomic_sub_unchecked(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_sub_return_unchecked(long i, atomic_long_unchecked_t *v)
{
	return atomic_sub_return_unchecked(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_inc(atomic_long_t *v)
{
	atomic_inc(v);
}

static inline long __turn_off_size_overflow
atomic_long_inc_return(atomic_long_t *v)
{
	return atomic_inc_return(v);
}

static inline long __turn_off_size_overflow
atomic_long_inc_return_acquire(atomic_long_t *v)
{
	return atomic_inc_return_acquire(v);
}

static inline long __turn_off_size_overflow
atomic_long_inc_return_release(atomic_long_t *v)
{
	return atomic_inc_return_release(v);
}

static inline long __turn_off_size_overflow
atomic_long_inc_return_relaxed(atomic_long_t *v)
{
	return atomic_inc_return_relaxed(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_inc(atomic_long_t *v)
{
	return atomic_fetch_inc(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_inc_acquire(atomic_long_t *v)
{
	return atomic_fetch_inc_acquire(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_inc_release(atomic_long_t *v)
{
	return atomic_fetch_inc_release(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_inc_relaxed(atomic_long_t *v)
{
	return atomic_fetch_inc_relaxed(v);
}

static inline void __turn_off_size_overflow
atomic_long_inc_unchecked(atomic_long_unchecked_t *v)
{
	atomic_inc_unchecked(v);
}

static inline long __turn_off_size_overflow
atomic_long_inc_return_unchecked(atomic_long_unchecked_t *v)
{
	return atomic_inc_return_unchecked(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_inc_unchecked(atomic_long_unchecked_t *v)
{
	return atomic_fetch_inc_unchecked(v);
}

static inline void __turn_off_size_overflow
atomic_long_dec(atomic_long_t *v)
{
	atomic_dec(v);
}

static inline long __turn_off_size_overflow
atomic_long_dec_return(atomic_long_t *v)
{
	return atomic_dec_return(v);
}

static inline long __turn_off_size_overflow
atomic_long_dec_return_acquire(atomic_long_t *v)
{
	return atomic_dec_return_acquire(v);
}

static inline long __turn_off_size_overflow
atomic_long_dec_return_release(atomic_long_t *v)
{
	return atomic_dec_return_release(v);
}

static inline long __turn_off_size_overflow
atomic_long_dec_return_relaxed(atomic_long_t *v)
{
	return atomic_dec_return_relaxed(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_dec(atomic_long_t *v)
{
	return atomic_fetch_dec(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_dec_acquire(atomic_long_t *v)
{
	return atomic_fetch_dec_acquire(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_dec_release(atomic_long_t *v)
{
	return atomic_fetch_dec_release(v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_dec_relaxed(atomic_long_t *v)
{
	return atomic_fetch_dec_relaxed(v);
}

static inline void __turn_off_size_overflow
atomic_long_dec_unchecked(atomic_long_unchecked_t *v)
{
	atomic_dec_unchecked(v);
}

static inline long __turn_off_size_overflow
atomic_long_dec_return_unchecked(atomic_long_unchecked_t *v)
{
	return atomic_dec_return_unchecked(v);
}

static inline void __turn_off_size_overflow
atomic_long_and(long i, atomic_long_t *v)
{
	atomic_and(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_and(long i, atomic_long_t *v)
{
	return atomic_fetch_and(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_and_acquire(long i, atomic_long_t *v)
{
	return atomic_fetch_and_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_and_release(long i, atomic_long_t *v)
{
	return atomic_fetch_and_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_and_relaxed(long i, atomic_long_t *v)
{
	return atomic_fetch_and_relaxed(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_andnot(long i, atomic_long_t *v)
{
	atomic_andnot(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_andnot(long i, atomic_long_t *v)
{
	return atomic_fetch_andnot(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_andnot_acquire(long i, atomic_long_t *v)
{
	return atomic_fetch_andnot_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_andnot_release(long i, atomic_long_t *v)
{
	return atomic_fetch_andnot_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_andnot_relaxed(long i, atomic_long_t *v)
{
	return atomic_fetch_andnot_relaxed(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_andnot_unchecked(long i, atomic_long_unchecked_t *v)
{
	atomic_andnot_unchecked(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_or(long i, atomic_long_t *v)
{
	atomic_or(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_or(long i, atomic_long_t *v)
{
	return atomic_fetch_or(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_or_acquire(long i, atomic_long_t *v)
{
	return atomic_fetch_or_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_or_release(long i, atomic_long_t *v)
{
	return atomic_fetch_or_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_or_relaxed(long i, atomic_long_t *v)
{
	return atomic_fetch_or_relaxed(i, v);
}

static inline void __turn_off_size_overflow
atomic_long_xor(long i, atomic_long_t *v)
{
	atomic_xor(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_xor(long i, atomic_long_t *v)
{
	return atomic_fetch_xor(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_xor_acquire(long i, atomic_long_t *v)
{
	return atomic_fetch_xor_acquire(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_xor_release(long i, atomic_long_t *v)
{
	return atomic_fetch_xor_release(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_xor_relaxed(long i, atomic_long_t *v)
{
	return atomic_fetch_xor_relaxed(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_xchg(atomic_long_t *v, long i)
{
	return atomic_xchg(v, i);
}

static inline long __turn_off_size_overflow
atomic_long_xchg_acquire(atomic_long_t *v, long i)
{
	return atomic_xchg_acquire(v, i);
}

static inline long __turn_off_size_overflow
atomic_long_xchg_release(atomic_long_t *v, long i)
{
	return atomic_xchg_release(v, i);
}

static inline long __turn_off_size_overflow
atomic_long_xchg_relaxed(atomic_long_t *v, long i)
{
	return atomic_xchg_relaxed(v, i);
}

static inline long __turn_off_size_overflow
atomic_long_xchg_unchecked(atomic_long_unchecked_t *v, long i)
{
	return atomic_xchg_unchecked(v, i);
}

static inline long __turn_off_size_overflow
atomic_long_cmpxchg(atomic_long_t *v, long old, long new)
{
	return atomic_cmpxchg(v, old, new);
}

static inline long __turn_off_size_overflow
atomic_long_cmpxchg_acquire(atomic_long_t *v, long old, long new)
{
	return atomic_cmpxchg_acquire(v, old, new);
}

static inline long __turn_off_size_overflow
atomic_long_cmpxchg_release(atomic_long_t *v, long old, long new)
{
	return atomic_cmpxchg_release(v, old, new);
}

static inline long __turn_off_size_overflow
atomic_long_cmpxchg_relaxed(atomic_long_t *v, long old, long new)
{
	return atomic_cmpxchg_relaxed(v, old, new);
}

static inline long __turn_off_size_overflow
atomic_long_cmpxchg_unchecked(atomic_long_unchecked_t *v, long old, long new)
{
	return atomic_cmpxchg_unchecked(v, old, new);
}

static inline bool __turn_off_size_overflow
atomic_long_try_cmpxchg(atomic_long_t *v, long *old, long new)
{
	return atomic_try_cmpxchg(v, (int *)old, new);
}

static inline bool __turn_off_size_overflow
atomic_long_try_cmpxchg_acquire(atomic_long_t *v, long *old, long new)
{
	return atomic_try_cmpxchg_acquire(v, (int *)old, new);
}

static inline bool __turn_off_size_overflow
atomic_long_try_cmpxchg_release(atomic_long_t *v, long *old, long new)
{
	return atomic_try_cmpxchg_release(v, (int *)old, new);
}

static inline bool __turn_off_size_overflow
atomic_long_try_cmpxchg_relaxed(atomic_long_t *v, long *old, long new)
{
	return atomic_try_cmpxchg_relaxed(v, (int *)old, new);
}

static inline bool __turn_off_size_overflow
atomic_long_sub_and_test(long i, atomic_long_t *v)
{
	return atomic_sub_and_test(i, v);
}

static inline bool __turn_off_size_overflow
atomic_long_dec_and_test(atomic_long_t *v)
{
	return atomic_dec_and_test(v);
}

static inline bool __turn_off_size_overflow
atomic_long_inc_and_test(atomic_long_t *v)
{
	return atomic_inc_and_test(v);
}

static inline bool __turn_off_size_overflow
atomic_long_inc_and_test_unchecked(atomic_long_unchecked_t *v)
{
	return atomic_inc_and_test_unchecked(v);
}

static inline bool __turn_off_size_overflow
atomic_long_add_negative(long i, atomic_long_t *v)
{
	return atomic_add_negative(i, v);
}

static inline long __turn_off_size_overflow
atomic_long_fetch_add_unless(atomic_long_t *v, long a, long u)
{
	return atomic_fetch_add_unless(v, a, u);
}

static inline bool __turn_off_size_overflow
atomic_long_add_unless(atomic_long_t *v, long a, long u)
{
	return atomic_add_unless(v, a, u);
}

static inline bool __turn_off_size_overflow
atomic_long_inc_not_zero(atomic_long_t *v)
{
	return atomic_inc_not_zero(v);
}

static inline bool __turn_off_size_overflow
atomic_long_inc_unless_negative(atomic_long_t *v)
{
	return atomic_inc_unless_negative(v);
}

static inline bool __turn_off_size_overflow
atomic_long_dec_unless_positive(atomic_long_t *v)
{
	return atomic_dec_unless_positive(v);
}

static inline long __turn_off_size_overflow
atomic_long_dec_if_positive(atomic_long_t *v)
{
	return atomic_dec_if_positive(v);
}

#endif /* CONFIG_64BIT */

#ifdef CONFIG_PAX_REFCOUNT
static inline void pax_refcount_needs_these_functions(void)
{
	atomic_read_unchecked((atomic_unchecked_t *)NULL);
	atomic_set_unchecked((atomic_unchecked_t *)NULL, 0);
	atomic_add_unchecked(0, (atomic_unchecked_t *)NULL);
	atomic_sub_unchecked(0, (atomic_unchecked_t *)NULL);
	atomic_inc_unchecked((atomic_unchecked_t *)NULL);
	(void)atomic_inc_and_test_unchecked((atomic_unchecked_t *)NULL);
	atomic_inc_return_unchecked((atomic_unchecked_t *)NULL);
	atomic_fetch_inc_unchecked((atomic_unchecked_t *)NULL);
	atomic_add_return_unchecked(0, (atomic_unchecked_t *)NULL);
	atomic_sub_return_unchecked(0, (atomic_unchecked_t *)NULL);
	atomic_dec_unchecked((atomic_unchecked_t *)NULL);
	atomic_dec_return_unchecked((atomic_unchecked_t *)NULL);
	atomic_cmpxchg_unchecked((atomic_unchecked_t *)NULL, 0, 0);
	(void)atomic_xchg_unchecked((atomic_unchecked_t *)NULL, 0);
	atomic_andnot_unchecked(0, (atomic_unchecked_t *)NULL);

	atomic_long_read_unchecked((atomic_long_unchecked_t *)NULL);
	atomic_long_set_unchecked((atomic_long_unchecked_t *)NULL, 0);
	atomic_long_add_unchecked(0, (atomic_long_unchecked_t *)NULL);
	atomic_long_sub_unchecked(0, (atomic_long_unchecked_t *)NULL);
	atomic_long_inc_unchecked((atomic_long_unchecked_t *)NULL);
	atomic_long_add_return_unchecked(0, (atomic_long_unchecked_t *)NULL);
	atomic_long_sub_return_unchecked(0, (atomic_long_unchecked_t *)NULL);
	atomic_long_inc_return_unchecked((atomic_long_unchecked_t *)NULL);
	atomic_long_fetch_inc_unchecked((atomic_long_unchecked_t *)NULL);
	atomic_long_dec_unchecked((atomic_long_unchecked_t *)NULL);
	atomic_long_dec_return_unchecked((atomic_long_unchecked_t *)NULL);
	(void)atomic_long_cmpxchg_unchecked((atomic_long_unchecked_t *)NULL, 0, 0);
}
#else /* !CONFIG_PAX_REFCOUNT */

#ifndef atomic_read_unchecked
#define atomic_read_unchecked(v) atomic_read(v)
#endif

#ifndef atomic_set_unchecked
#define atomic_set_unchecked(v, i) atomic_set((v), (i))
#endif

#ifndef atomic_add_unchecked
#define atomic_add_unchecked(i, v) atomic_add((i), (v))
#endif

#ifndef atomic_sub_unchecked
#define atomic_sub_unchecked(i, v) atomic_sub((i), (v))
#endif

#ifndef atomic_inc_unchecked
#define atomic_inc_unchecked(v) atomic_inc(v)
#endif

#ifndef atomic_inc_and_test_unchecked
#define atomic_inc_and_test_unchecked(v) atomic_inc_and_test(v)
#endif

#ifndef atomic_inc_return_unchecked
#define atomic_inc_return_unchecked(v) atomic_inc_return(v)
#endif

#ifndef atomic_fetch_inc_unchecked
#define atomic_fetch_inc_unchecked(v) atomic_fetch_inc(v)
#endif

#ifndef atomic_add_return_unchecked
#define atomic_add_return_unchecked(i, v) atomic_add_return((i), (v))
#endif

#ifndef atomic_sub_return_unchecked
#define atomic_sub_return_unchecked(i, v) atomic_sub_return((i), (v))
#endif

#ifndef atomic_dec_unchecked
#define atomic_dec_unchecked(v) atomic_dec(v)
#endif

#ifndef atomic_dec_return_unchecked
#define atomic_dec_return_unchecked(v) atomic_dec_return(v)
#endif

#ifndef atomic_cmpxchg_unchecked
#define atomic_cmpxchg_unchecked(v, o, n) atomic_cmpxchg((v), (o), (n))
#endif

#ifndef atomic_xchg_unchecked
#define atomic_xchg_unchecked(v, i) atomic_xchg((v), (i))
#endif

#ifndef atomic_andnot_unchecked
#define atomic_andnot_unchecked(i, v) atomic_andnot((i), (v))
#endif

#define atomic_long_read_unchecked(v) atomic_long_read(v)
#define atomic_long_set_unchecked(v, i) atomic_long_set((v), (i))
#define atomic_long_add_unchecked(i, v) atomic_long_add((i), (v))
#define atomic_long_sub_unchecked(i, v) atomic_long_sub((i), (v))
#define atomic_long_inc_unchecked(v) atomic_long_inc(v)
#define atomic_long_fetch_inc_unchecked(v) atomic_long_fetch_inc(v)
#define atomic_long_add_return_unchecked(i, v) atomic_long_add_return((i), (v))
#define atomic_long_sub_return_unchecked(i, v) atomic_long_sub_return((i), (v))
#define atomic_long_inc_return_unchecked(v) atomic_long_inc_return(v)
#define atomic_long_dec_unchecked(v) atomic_long_dec(v)
#define atomic_long_dec_return_unchecked(v) atomic_long_dec_return(v)

#ifndef atomic_long_xchg_unchecked
#define atomic_long_xchg_unchecked(v, i) atomic_long_xchg((v), (i))
#endif

#ifndef atomic_long_cmpxchg_unchecked
#define atomic_long_cmpxchg_unchecked(v, o, n) atomic_long_cmpxchg((v), (o), (n))
#endif

#endif /* CONFIG_PAX_REFCOUNT */

#endif /* _ASM_GENERIC_ATOMIC_LONG_H */
// f3ee9c341bd0842cc2d1f60821c153c7cc3cca8f
