/*
 * Copyright 2021 by PaX Team <pageexec@freemail.hu>
 * Licensed under the GPL v2
 *
 * implement the 'noderef' type attribute
 *
 * TODO: implement its full semantics, see https://git.kernel.org/pub/scm/devel/sparse/sparse.git/tree/validation/noderef.c
 *       for now its mere existence on a type is all we need for RAP/rap_cgraph_indirectly_called
 */

#include "utilities.h"

static tree handle_noderef_attribute(tree *node, tree name, tree args, int flags, bool *no_add_attrs)
{
	tree type;

	*no_add_attrs = true;
	type = *node;

	if (!POINTER_TYPE_P(type)) {
		warning_at(UNKNOWN_LOCATION, OPT_Wattributes, "%qE attribute only applies to pointer types", name);
		return NULL_TREE;
	}

	*no_add_attrs = false;
	return NULL_TREE;
}

struct attribute_spec noderef_flags_attr = ATTRIBUTE_SPEC_INIT("noderef", 0, 0, false, true, false, handle_noderef_attribute, true, NULL);
